import _default2 from 'antd/lib/button';
import _default from 'antd/lib/icon';
import React from 'react';

import PropTypes from 'prop-types';

function noop() {}

var Operation = function Operation(_ref) {
    var moveToLeft = _ref.moveToLeft,
        moveToRight = _ref.moveToRight,
        leftArrowText = _ref.leftArrowText,
        rightArrowText = _ref.rightArrowText,
        leftActive = _ref.leftActive,
        rightActive = _ref.rightActive,
        className = _ref.className;

    var moveToLeftButton = React.createElement(
        _default2,
        { type: 'primary', size: 'small', disabled: !leftActive, onClick: moveToLeft },
        React.createElement(
            'span',
            null,
            React.createElement(_default, { type: 'left' }),
            leftArrowText
        )
    );
    var moveToRightButton = React.createElement(
        _default2,
        { type: 'primary', size: 'small', disabled: !rightActive, onClick: moveToRight },
        React.createElement(
            'span',
            null,
            rightArrowText,
            React.createElement(_default, { type: 'right' })
        )
    );
    return React.createElement(
        'div',
        { className: className },
        moveToLeftButton,
        moveToRightButton
    );
};

Operation.defaultProps = {
    leftArrowText: '',
    rightArrowText: '',
    moveToLeft: noop,
    moveToRight: noop
};

Operation.propTypes = {
    moveToLeft: PropTypes.func,
    moveToRight: PropTypes.func,
    leftArrowText: PropTypes.string,
    rightArrowText: PropTypes.string,
    leftActive: PropTypes.bool.isRequired,
    rightActive: PropTypes.bool.isRequired,
    className: PropTypes.string.isRequired
};

export default Operation;