import _default from 'antd/lib/checkbox';
import _Object$assign from 'babel-runtime/core-js/object/assign';
import _defineProperty from 'babel-runtime/helpers/defineProperty';
import _toConsumableArray from 'babel-runtime/helpers/toConsumableArray';
import _Object$getPrototypeOf from 'babel-runtime/core-js/object/get-prototype-of';
import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _createClass from 'babel-runtime/helpers/createClass';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
import _debounce from 'lodash/debounce';
import React from 'react';
import PureRenderMixin from 'rc-util/lib/PureRenderMixin';
import { List } from 'react-virtualized';
import PropTypes from 'prop-types';
import classNames from 'classnames';


import Item from './item';
import Search from './search';
import prefixCls from './constants';

function noop() {}

function isRenderResultPlainObject(result) {
    return result && !React.isValidElement(result) && Object.prototype.toString.call(result) === '[object Object]';
}

var SelectList = function (_React$Component) {
    _inherits(SelectList, _React$Component);

    function SelectList(props) {
        _classCallCheck(this, SelectList);

        var _this = _possibleConstructorReturn(this, (SelectList.__proto__ || _Object$getPrototypeOf(SelectList)).call(this, props));

        _this.state = {
            filter: '',
            dataSource: []
        };

        _this.renderItem = _this.renderItem.bind(_this);
        _this.rowRenderer = _this.rowRenderer.bind(_this);
        _this.handleSelect = _this.handleSelect.bind(_this);
        _this.handleSelectAll = _this.handleSelectAll.bind(_this);
        _this.handleFilterWapper = _this.handleFilterWapper.bind(_this);
        _this.handleFilterWithDebounce = _debounce(_this.handleFilter.bind(_this), 200);
        _this.handleFilter = _this.handleFilter.bind(_this);
        _this.handleClear = _this.handleClear.bind(_this);
        _this.matchFilter = _this.matchFilter.bind(_this);
        return _this;
    }

    _createClass(SelectList, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
            this.setState({
                dataSource: this.props.dataSource
            });
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if (nextProps.dataSource !== this.props.dataSource) {
                if (this.state.filter !== '') {
                    this.handleFilter(nextProps.dataSource, this.state.filter);
                } else {
                    this.setState({
                        dataSource: nextProps.dataSource
                    });
                }
            }
        }
    }, {
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate(nextProps, nextState) {
            if (PureRenderMixin.shouldComponentUpdate.apply(this, nextProps, nextState)) {
                return true;
            }
            return false;
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate() {
            /**
             * Sometimes there will be called redundant, but call forceUpdateGrid there every time is
             * the easyest way to ensure right update
             */
            this.list.forceUpdateGrid();
        }
    }, {
        key: 'getCheckStatus',
        value: function getCheckStatus() {
            var selectedKeys = this.props.selectedKeys;
            var dataSource = this.state.dataSource;

            if (selectedKeys.length === 0) {
                return 'none';
            } else if (dataSource.every(function (item) {
                return item.disabled || selectedKeys.indexOf(item.key) >= 0;
            })) {
                return 'all';
            }
            return 'part';
        }
    }, {
        key: 'handleSelect',
        value: function handleSelect(selectedItem) {
            var selectedKeys = this.props.selectedKeys;

            var hoder = [].concat(_toConsumableArray(selectedKeys));
            var index = hoder.indexOf(selectedItem.key);
            if (index > -1) {
                hoder.splice(index, 1);
            } else {
                hoder.push(selectedItem.key);
            }
            this.props.handleSelect(hoder);
        }
    }, {
        key: 'handleSelectAll',
        value: function handleSelectAll(checkAll) {
            var dataSource = this.state.dataSource;
            var selectedKeys = this.props.selectedKeys;

            var hoder = [].concat(_toConsumableArray(selectedKeys));
            var index = void 0;
            if (!checkAll) {
                dataSource.map(function (item) {
                    if (!item.disabled && hoder.indexOf(item.key) < 0) {
                        hoder.push(item.key);
                    }
                    return item;
                });
            } else {
                dataSource.map(function (item) {
                    index = hoder.indexOf(item.key);
                    if (index > -1) {
                        hoder.splice(index, 1);
                    }
                    return item;
                });
            }
            this.props.handleSelect(hoder);
        }
    }, {
        key: 'handleFilterWapper',
        value: function handleFilterWapper(e) {
            this.handleFilterWithDebounce(this.props.dataSource, e.target.value);
            this.setState({
                filter: e.target.value
            });
        }
    }, {
        key: 'matchFilter',
        value: function matchFilter(filter, item) {
            if (this.props.filterOption) {
                return this.props.filterOption(filter, item);
            }

            var _renderItem = this.renderItem(item),
                renderedText = _renderItem.renderedText;

            return renderedText.indexOf(filter) >= 0;
        }
    }, {
        key: 'handleFilter',
        value: function handleFilter(dataSource, filter) {
            var _this2 = this;

            var showItems = [];
            dataSource.map(function (item) {
                if (!_this2.matchFilter(filter, item)) {
                    return null;
                }
                showItems.push(item);
                return item;
            });
            this.setState({
                dataSource: showItems
            }, function () {
                /* TODO: maybe we can scroll to the position which user is looking at*/
                _this2.list.scrollToRow(0);
            });
        }
    }, {
        key: 'handleClear',
        value: function handleClear() {
            this.setState({
                filter: '',
                dataSource: this.props.dataSource
            });
        }
    }, {
        key: 'rowRenderer',
        value: function rowRenderer(_ref) {
            var _key = _ref._key,
                index = _ref.index,
                _isScrolling = _ref._isScrolling,
                _isVisible = _ref._isVisible,
                _parent = _ref._parent,
                style = _ref.style;

            var item = this.state.dataSource[index];

            var _renderItem2 = this.renderItem(item),
                renderedText = _renderItem2.renderedText,
                renderedEl = _renderItem2.renderedEl;

            var checked = this.props.selectedKeys.indexOf(item.key) >= 0;
            var itemPrefixCls = prefixCls + '-list';

            if (this.props.rowKey) {
                item.key = this.props.rowKey(item);
            }

            return React.createElement(Item, {
                key: item.key,
                item: item,
                checked: checked,
                style: style,
                renderedText: renderedText,
                renderedEl: renderedEl,
                disabled: item.disabled,
                onClick: this.handleSelect,
                prefixCls: itemPrefixCls
            });
        }
    }, {
        key: 'renderItem',
        value: function renderItem(item) {
            var _props$render = this.props.render,
                render = _props$render === undefined ? noop : _props$render;

            var renderResult = render(item);
            var isRenderResultPlain = isRenderResultPlainObject(renderResult);
            return {
                renderedText: isRenderResultPlain ? renderResult.value : renderResult,
                renderedEl: isRenderResultPlain ? renderResult.label : renderResult
            };
        }
    }, {
        key: 'render',
        value: function render() {
            var _this3 = this;

            var _props = this.props,
                footer = _props.footer,
                showSearch = _props.showSearch,
                showHeader = _props.showHeader,
                selectedKeys = _props.selectedKeys,
                itemUnit = _props.itemUnit,
                itemsUnit = _props.itemsUnit,
                titleText = _props.titleText,
                style = _props.style,
                notFoundContent = _props.notFoundContent,
                searchPlaceholder = _props.searchPlaceholder;
            var dataSource = this.state.dataSource;


            var className = classNames(_defineProperty({}, prefixCls + '-list', true));

            var footerDom = footer(_Object$assign({}, this.props));

            var listFooter = footerDom ? React.createElement(
                'div',
                { className: prefixCls + '-list-footer' },
                footerDom
            ) : null;

            var checkStatus = this.getCheckStatus();
            var checkedAll = checkStatus === 'all';
            var checkAllCheckbox = React.createElement(_default, {
                checked: checkedAll,
                indeterminate: checkStatus === 'part',
                onChange: function onChange() {
                    return _this3.handleSelectAll(checkedAll);
                }
            });
            var unit = dataSource.length > 1 ? itemsUnit : itemUnit;

            // height is not 100%, so there should minus 2px of the boder of transfer-list
            var bodyHeight = style.height - 2;
            bodyHeight = showHeader ? bodyHeight - 33 : bodyHeight;
            bodyHeight = showSearch ? bodyHeight - 38 : bodyHeight;
            bodyHeight = listFooter !== null ? bodyHeight - 32 : bodyHeight;

            var header = showHeader ? React.createElement(
                'div',
                { className: prefixCls + '-list-header' },
                checkAllCheckbox,
                React.createElement(
                    'span',
                    { className: prefixCls + '-list-header-selected' },
                    React.createElement(
                        'span',
                        null,
                        (selectedKeys.length > 0 ? selectedKeys.length + '/' : '') + dataSource.length,
                        ' ',
                        unit
                    ),
                    React.createElement(
                        'span',
                        { className: prefixCls + '-list-header-title' },
                        titleText
                    )
                )
            ) : null;

            var search = showSearch ? React.createElement(Search, {
                value: this.state.filter,
                onChange: this.handleFilterWapper,
                handleClear: this.handleClear,
                prefixCls: prefixCls + '-list-search',
                placeholder: searchPlaceholder
            }) : null;

            return React.createElement(
                'div',
                { className: className, style: style },
                header,
                search,
                React.createElement(List, {
                    ref: function ref(list) {
                        _this3.list = list;
                    },
                    height: dataSource.length === 0 ? 0 : bodyHeight,
                    rowCount: dataSource.length,
                    rowHeight: this.props.rowHeight,
                    rowRenderer: this.rowRenderer,
                    width: 1,
                    className: prefixCls + '-list-virtualized'
                }),
                dataSource.length === 0 && React.createElement(
                    'div',
                    {
                        className: prefixCls + '-list-body-not-found',
                        style: {
                            height: bodyHeight + 'px',
                            lineHeight: bodyHeight + 'px'
                        }
                    },
                    notFoundContent
                ),
                listFooter
            );
        }
    }]);

    return SelectList;
}(React.Component);

export default SelectList;


SelectList.defaultProps = {
    filterOption: undefined,
    footer: noop,
    showSearch: false,
    showHeader: true,
    itemUnit: '',
    itemsUnit: '',
    titleText: '',
    style: {
        width: 200,
        height: 300
    },
    notFoundContent: 'Not Found',
    searchPlaceholder: 'Search here',
    rowKey: undefined
};

SelectList.propTypes = {
    render: PropTypes.func.isRequired,
    dataSource: PropTypes.array.isRequired,
    selectedKeys: PropTypes.array.isRequired,
    handleSelect: PropTypes.func.isRequired,
    filterOption: PropTypes.func,
    footer: PropTypes.func,
    showSearch: PropTypes.bool,
    showHeader: PropTypes.bool,
    itemUnit: PropTypes.string,
    itemsUnit: PropTypes.string,
    titleText: PropTypes.string,
    rowHeight: PropTypes.number.isRequired,
    style: PropTypes.shape({
        height: PropTypes.number.isRequired, // not support %
        width: PropTypes.any
    }),
    notFoundContent: PropTypes.string,
    searchPlaceholder: PropTypes.string,
    rowKey: PropTypes.func
};