import _defineProperty from 'babel-runtime/helpers/defineProperty';
import _Object$getPrototypeOf from 'babel-runtime/core-js/object/get-prototype-of';
import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _createClass from 'babel-runtime/helpers/createClass';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
import 'react-virtualized/styles.css';
import React from 'react';
import PureRenderMixin from 'rc-util/lib/PureRenderMixin';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import 'core-js/fn/array/includes';
import SelectList from './selectList';
import Operation from './operation';

import prefixCls from './constants';

function noop() {}

var Transfer = function (_React$Component) {
    _inherits(Transfer, _React$Component);

    function Transfer(props) {
        _classCallCheck(this, Transfer);

        var _this = _possibleConstructorReturn(this, (Transfer.__proto__ || _Object$getPrototypeOf(Transfer)).call(this, props));

        _this.state = {
            leftSource: [],
            rightSrouce: [],
            sourceSelectedKeys: [],
            targetSelectedKeys: []
        };

        _this.handleSelect = _this.handleSelect.bind(_this);
        _this.initStateByProps = _this.initStateByProps.bind(_this);
        _this.moveTo = _this.moveTo.bind(_this);
        _this.moveToLeft = _this.moveToLeft.bind(_this);
        _this.moveToRight = _this.moveToRight.bind(_this);
        return _this;
    }

    _createClass(Transfer, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
            this.initStateByProps(this.props);
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if (nextProps.dataSource !== this.props.dataSource || nextProps.targetKeys !== this.props.targetKeys || nextProps.selectedKeys !== this.props.selectedKeys) {
                this.initStateByProps(nextProps, true);
            }
        }
    }, {
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate() {
            for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
                args[_key] = arguments[_key];
            }

            return PureRenderMixin.shouldComponentUpdate.apply(this, args);
        }
    }, {
        key: 'getSelectedKeysName',
        value: function getSelectedKeysName(direction) {
            return direction === 'left' ? 'sourceSelectedKeys' : 'targetSelectedKeys';
        }
    }, {
        key: 'initStateByProps',
        value: function initStateByProps(props, update) {
            var leftSource = [];
            var rightSrouce = new Array(props.targetKeys.length);
            var sourceSelectedKeys = [];
            var targetSelectedKeys = [];
            var oldSourceSelectedKeys = this.state.sourceSelectedKeys;
            var oldTargetSelectedKeys = this.state.targetSelectedKeys;

            props.dataSource.forEach(function (item) {
                if (props.rowKey) {
                    item.key = props.rowKey(item); // eslint-disable-line
                }

                // rightSource should be ordered by targetKeys
                // leftSource should be ordered by dataSource
                var indexOfKey = props.targetKeys.indexOf(item.key);
                if (indexOfKey !== -1) {
                    rightSrouce[indexOfKey] = item;
                } else {
                    leftSource.push(item);
                }

                if (!props.selectedKeys && update) {
                    // fitler not exist keys
                    if (oldSourceSelectedKeys.includes(item.key) && !props.targetKeys.includes(item.key)) {
                        sourceSelectedKeys.push(item.key);
                    }
                    if (oldTargetSelectedKeys.includes(item.key) && props.targetKeys.includes(item.key)) {
                        targetSelectedKeys.push(item.key);
                    }
                }
            });

            if (props.selectedKeys) {
                props.selectedKeys.forEach(function (key) {
                    if (props.targetKeys.includes(key)) {
                        targetSelectedKeys.push(key);
                    } else {
                        sourceSelectedKeys.push(key);
                    }
                });
            }

            this.setState({
                leftSource: leftSource,
                rightSrouce: rightSrouce,
                sourceSelectedKeys: sourceSelectedKeys,
                targetSelectedKeys: targetSelectedKeys
            });
        }
    }, {
        key: 'handleSelect',
        value: function handleSelect(direction, selectedKeys) {
            var leftKeys = direction === 'left' ? selectedKeys : this.state.sourceSelectedKeys;
            var rightKeys = direction === 'right' ? selectedKeys : this.state.targetSelectedKeys;
            var onSelectChange = this.props.onSelectChange;

            if (onSelectChange) {
                onSelectChange(leftKeys, rightKeys);
            }

            if (!this.props.selectedKeys) {
                this.setState({
                    sourceSelectedKeys: leftKeys,
                    targetSelectedKeys: rightKeys
                });
            }
        }
    }, {
        key: 'moveTo',
        value: function moveTo(direction) {
            var _props = this.props,
                _props$targetKeys = _props.targetKeys,
                targetKeys = _props$targetKeys === undefined ? [] : _props$targetKeys,
                _props$dataSource = _props.dataSource,
                dataSource = _props$dataSource === undefined ? [] : _props$dataSource,
                onChange = _props.onChange;
            var _state = this.state,
                sourceSelectedKeys = _state.sourceSelectedKeys,
                targetSelectedKeys = _state.targetSelectedKeys;

            var moveKeys = direction === 'right' ? sourceSelectedKeys : targetSelectedKeys;

            var newMoveKeys = [];
            // disable key can be selected in props, so there should fitler disabled keys
            dataSource.forEach(function (item) {
                if (!item.disabled && moveKeys.includes(item.key)) {
                    newMoveKeys.push(item.key);
                }
            });
            // move items to target box
            var newTargetKeys = direction === 'right' ? newMoveKeys.concat(targetKeys) : targetKeys.filter(function (targetKey) {
                return newMoveKeys.indexOf(targetKey) === -1;
            });
            // empty checked keys
            var oppositeDirection = direction === 'right' ? 'left' : 'right';
            this.setState(_defineProperty({}, this.getSelectedKeysName(oppositeDirection), []));
            this.handleSelect(oppositeDirection, []);
            if (onChange) {
                onChange(newTargetKeys, direction, newMoveKeys);
            }
        }
    }, {
        key: 'moveToLeft',
        value: function moveToLeft() {
            this.moveTo('left');
        }
    }, {
        key: 'moveToRight',
        value: function moveToRight() {
            this.moveTo('right');
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var _state2 = this.state,
                sourceSelectedKeys = _state2.sourceSelectedKeys,
                targetSelectedKeys = _state2.targetSelectedKeys;
            var _props2 = this.props,
                titles = _props2.titles,
                className = _props2.className,
                filterOption = _props2.filterOption,
                showSearch = _props2.showSearch,
                footer = _props2.footer,
                notFoundContent = _props2.notFoundContent,
                searchPlaceholder = _props2.searchPlaceholder;

            var leftActive = targetSelectedKeys.length > 0;
            var rightActive = sourceSelectedKeys.length > 0;

            var cls = classNames(_defineProperty({}, '' + prefixCls, true), className);

            return React.createElement(
                'div',
                { className: cls },
                React.createElement(SelectList, {
                    dataSource: this.state.leftSource,
                    render: this.props.render,
                    selectedKeys: this.state.sourceSelectedKeys,
                    handleSelect: function handleSelect(selectedKeys) {
                        return _this2.handleSelect('left', selectedKeys);
                    },
                    showSearch: showSearch,
                    filterOption: filterOption,
                    itemsUnit: 'items',
                    itemUnit: 'item',
                    titleText: titles[0],
                    rowHeight: this.props.rowHeight,
                    style: this.props.listStyle,
                    footer: footer,
                    notFoundContent: notFoundContent,
                    searchPlaceholder: searchPlaceholder
                }),
                React.createElement(Operation, {
                    className: prefixCls + '-operation',
                    leftActive: leftActive,
                    rightActive: rightActive,
                    moveToLeft: this.moveToLeft,
                    moveToRight: this.moveToRight,
                    leftArrowText: this.props.operations[0],
                    rightArrowText: this.props.operations[1]
                }),
                React.createElement(SelectList, {
                    dataSource: this.state.rightSrouce,
                    render: this.props.render,
                    selectedKeys: this.state.targetSelectedKeys,
                    handleSelect: function handleSelect(selectedKeys) {
                        return _this2.handleSelect('right', selectedKeys);
                    },
                    showSearch: showSearch,
                    filterOption: filterOption,
                    itemsUnit: 'items',
                    itemUnit: 'item',
                    titleText: titles[1],
                    rowHeight: this.props.rowHeight,
                    style: this.props.listStyle,
                    footer: footer,
                    notFoundContent: notFoundContent,
                    searchPlaceholder: searchPlaceholder
                })
            );
        }
    }]);

    return Transfer;
}(React.Component);

export default Transfer;


Transfer.defaultProps = {
    dataSource: [],
    selectedKeys: undefined,
    onSelectChange: undefined,
    titles: ['', ''],
    className: undefined,
    filterOption: undefined,
    listStyle: {
        width: 200,
        height: 300
    },
    operations: ['', ''],
    showSearch: false,
    footer: noop,
    notFoundContent: 'Not Found',
    searchPlaceholder: 'Search here',
    rowKey: undefined,
    onChange: undefined
};

Transfer.propTypes = {
    dataSource: PropTypes.array,
    render: PropTypes.func.isRequired,
    targetKeys: PropTypes.array.isRequired,
    selectedKeys: PropTypes.array,
    onChange: PropTypes.func,
    onSelectChange: PropTypes.func,
    listStyle: PropTypes.shape({
        height: PropTypes.number.isRequired, // not support %
        width: PropTypes.any
    }),
    className: PropTypes.string,
    titles: PropTypes.array,
    operations: PropTypes.array,
    showSearch: PropTypes.bool,
    filterOption: PropTypes.func,
    searchPlaceholder: PropTypes.string,
    notFoundContent: PropTypes.string,
    rowHeight: PropTypes.number.isRequired,
    footer: PropTypes.func,
    rowKey: PropTypes.func };