'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _button = require('antd/lib/button');

var _button2 = _interopRequireDefault(_button);

var _icon = require('antd/lib/icon');

var _icon2 = _interopRequireDefault(_icon);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function noop() {}

var Operation = function Operation(_ref) {
    var moveToLeft = _ref.moveToLeft,
        moveToRight = _ref.moveToRight,
        leftArrowText = _ref.leftArrowText,
        rightArrowText = _ref.rightArrowText,
        leftActive = _ref.leftActive,
        rightActive = _ref.rightActive,
        className = _ref.className;

    var moveToLeftButton = _react2.default.createElement(
        _button2.default,
        { type: 'primary', size: 'small', disabled: !leftActive, onClick: moveToLeft },
        _react2.default.createElement(
            'span',
            null,
            _react2.default.createElement(_icon2.default, { type: 'left' }),
            leftArrowText
        )
    );
    var moveToRightButton = _react2.default.createElement(
        _button2.default,
        { type: 'primary', size: 'small', disabled: !rightActive, onClick: moveToRight },
        _react2.default.createElement(
            'span',
            null,
            rightArrowText,
            _react2.default.createElement(_icon2.default, { type: 'right' })
        )
    );
    return _react2.default.createElement(
        'div',
        { className: className },
        moveToLeftButton,
        moveToRightButton
    );
};

Operation.defaultProps = {
    leftArrowText: '',
    rightArrowText: '',
    moveToLeft: noop,
    moveToRight: noop
};

Operation.propTypes = {
    moveToLeft: _propTypes2.default.func,
    moveToRight: _propTypes2.default.func,
    leftArrowText: _propTypes2.default.string,
    rightArrowText: _propTypes2.default.string,
    leftActive: _propTypes2.default.bool.isRequired,
    rightActive: _propTypes2.default.bool.isRequired,
    className: _propTypes2.default.string.isRequired
};

exports.default = Operation;