'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _checkbox = require('antd/lib/checkbox');

var _checkbox2 = _interopRequireDefault(_checkbox);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _debounce2 = require('lodash/debounce');

var _debounce3 = _interopRequireDefault(_debounce2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _PureRenderMixin = require('rc-util/lib/PureRenderMixin');

var _PureRenderMixin2 = _interopRequireDefault(_PureRenderMixin);

var _reactVirtualized = require('react-virtualized');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _item = require('./item');

var _item2 = _interopRequireDefault(_item);

var _search = require('./search');

var _search2 = _interopRequireDefault(_search);

var _constants = require('./constants');

var _constants2 = _interopRequireDefault(_constants);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function noop() {}

function isRenderResultPlainObject(result) {
    return result && !_react2.default.isValidElement(result) && Object.prototype.toString.call(result) === '[object Object]';
}

var SelectList = function (_React$Component) {
    (0, _inherits3.default)(SelectList, _React$Component);

    function SelectList(props) {
        (0, _classCallCheck3.default)(this, SelectList);

        var _this = (0, _possibleConstructorReturn3.default)(this, (SelectList.__proto__ || (0, _getPrototypeOf2.default)(SelectList)).call(this, props));

        _this.state = {
            filter: '',
            dataSource: []
        };

        _this.renderItem = _this.renderItem.bind(_this);
        _this.rowRenderer = _this.rowRenderer.bind(_this);
        _this.handleSelect = _this.handleSelect.bind(_this);
        _this.handleSelectAll = _this.handleSelectAll.bind(_this);
        _this.handleFilterWapper = _this.handleFilterWapper.bind(_this);
        _this.handleFilterWithDebounce = (0, _debounce3.default)(_this.handleFilter.bind(_this), 200);
        _this.handleFilter = _this.handleFilter.bind(_this);
        _this.handleClear = _this.handleClear.bind(_this);
        _this.matchFilter = _this.matchFilter.bind(_this);
        return _this;
    }

    (0, _createClass3.default)(SelectList, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
            this.setState({
                dataSource: this.props.dataSource
            });
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if (nextProps.dataSource !== this.props.dataSource) {
                if (this.state.filter !== '') {
                    this.handleFilter(nextProps.dataSource, this.state.filter);
                } else {
                    this.setState({
                        dataSource: nextProps.dataSource
                    });
                }
            }
        }
    }, {
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate(nextProps, nextState) {
            if (_PureRenderMixin2.default.shouldComponentUpdate.apply(this, nextProps, nextState)) {
                return true;
            }
            return false;
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate() {
            /**
             * Sometimes there will be called redundant, but call forceUpdateGrid there every time is
             * the easyest way to ensure right update
             */
            this.list.forceUpdateGrid();
        }
    }, {
        key: 'getCheckStatus',
        value: function getCheckStatus() {
            var selectedKeys = this.props.selectedKeys;
            var dataSource = this.state.dataSource;

            if (selectedKeys.length === 0) {
                return 'none';
            } else if (dataSource.every(function (item) {
                return item.disabled || selectedKeys.indexOf(item.key) >= 0;
            })) {
                return 'all';
            }
            return 'part';
        }
    }, {
        key: 'handleSelect',
        value: function handleSelect(selectedItem) {
            var selectedKeys = this.props.selectedKeys;

            var hoder = [].concat((0, _toConsumableArray3.default)(selectedKeys));
            var index = hoder.indexOf(selectedItem.key);
            if (index > -1) {
                hoder.splice(index, 1);
            } else {
                hoder.push(selectedItem.key);
            }
            this.props.handleSelect(hoder);
        }
    }, {
        key: 'handleSelectAll',
        value: function handleSelectAll(checkAll) {
            var dataSource = this.state.dataSource;
            var selectedKeys = this.props.selectedKeys;

            var hoder = [].concat((0, _toConsumableArray3.default)(selectedKeys));
            var index = void 0;
            if (!checkAll) {
                dataSource.map(function (item) {
                    if (!item.disabled && hoder.indexOf(item.key) < 0) {
                        hoder.push(item.key);
                    }
                    return item;
                });
            } else {
                dataSource.map(function (item) {
                    index = hoder.indexOf(item.key);
                    if (index > -1) {
                        hoder.splice(index, 1);
                    }
                    return item;
                });
            }
            this.props.handleSelect(hoder);
        }
    }, {
        key: 'handleFilterWapper',
        value: function handleFilterWapper(e) {
            this.handleFilterWithDebounce(this.props.dataSource, e.target.value);
            this.setState({
                filter: e.target.value
            });
        }
    }, {
        key: 'matchFilter',
        value: function matchFilter(filter, item) {
            if (this.props.filterOption) {
                return this.props.filterOption(filter, item);
            }

            var _renderItem = this.renderItem(item),
                renderedText = _renderItem.renderedText;

            return renderedText.indexOf(filter) >= 0;
        }
    }, {
        key: 'handleFilter',
        value: function handleFilter(dataSource, filter) {
            var _this2 = this;

            var showItems = [];
            dataSource.map(function (item) {
                if (!_this2.matchFilter(filter, item)) {
                    return null;
                }
                showItems.push(item);
                return item;
            });
            this.setState({
                dataSource: showItems
            }, function () {
                /* TODO: maybe we can scroll to the position which user is looking at*/
                _this2.list.scrollToRow(0);
            });
        }
    }, {
        key: 'handleClear',
        value: function handleClear() {
            this.setState({
                filter: '',
                dataSource: this.props.dataSource
            });
        }
    }, {
        key: 'rowRenderer',
        value: function rowRenderer(_ref) {
            var _key = _ref._key,
                index = _ref.index,
                _isScrolling = _ref._isScrolling,
                _isVisible = _ref._isVisible,
                _parent = _ref._parent,
                style = _ref.style;

            var item = this.state.dataSource[index];

            var _renderItem2 = this.renderItem(item),
                renderedText = _renderItem2.renderedText,
                renderedEl = _renderItem2.renderedEl;

            var checked = this.props.selectedKeys.indexOf(item.key) >= 0;
            var itemPrefixCls = _constants2.default + '-list';

            if (this.props.rowKey) {
                item.key = this.props.rowKey(item);
            }

            return _react2.default.createElement(_item2.default, {
                key: item.key,
                item: item,
                checked: checked,
                style: style,
                renderedText: renderedText,
                renderedEl: renderedEl,
                disabled: item.disabled,
                onClick: this.handleSelect,
                prefixCls: itemPrefixCls
            });
        }
    }, {
        key: 'renderItem',
        value: function renderItem(item) {
            var _props$render = this.props.render,
                render = _props$render === undefined ? noop : _props$render;

            var renderResult = render(item);
            var isRenderResultPlain = isRenderResultPlainObject(renderResult);
            return {
                renderedText: isRenderResultPlain ? renderResult.value : renderResult,
                renderedEl: isRenderResultPlain ? renderResult.label : renderResult
            };
        }
    }, {
        key: 'render',
        value: function render() {
            var _this3 = this;

            var _props = this.props,
                footer = _props.footer,
                showSearch = _props.showSearch,
                showHeader = _props.showHeader,
                selectedKeys = _props.selectedKeys,
                itemUnit = _props.itemUnit,
                itemsUnit = _props.itemsUnit,
                titleText = _props.titleText,
                style = _props.style,
                notFoundContent = _props.notFoundContent,
                searchPlaceholder = _props.searchPlaceholder;
            var dataSource = this.state.dataSource;


            var className = (0, _classnames2.default)((0, _defineProperty3.default)({}, _constants2.default + '-list', true));

            var footerDom = footer((0, _assign2.default)({}, this.props));

            var listFooter = footerDom ? _react2.default.createElement(
                'div',
                { className: _constants2.default + '-list-footer' },
                footerDom
            ) : null;

            var checkStatus = this.getCheckStatus();
            var checkedAll = checkStatus === 'all';
            var checkAllCheckbox = _react2.default.createElement(_checkbox2.default, {
                checked: checkedAll,
                indeterminate: checkStatus === 'part',
                onChange: function onChange() {
                    return _this3.handleSelectAll(checkedAll);
                }
            });
            var unit = dataSource.length > 1 ? itemsUnit : itemUnit;

            // height is not 100%, so there should minus 2px of the boder of transfer-list
            var bodyHeight = style.height - 2;
            bodyHeight = showHeader ? bodyHeight - 33 : bodyHeight;
            bodyHeight = showSearch ? bodyHeight - 38 : bodyHeight;
            bodyHeight = listFooter !== null ? bodyHeight - 32 : bodyHeight;

            var header = showHeader ? _react2.default.createElement(
                'div',
                { className: _constants2.default + '-list-header' },
                checkAllCheckbox,
                _react2.default.createElement(
                    'span',
                    { className: _constants2.default + '-list-header-selected' },
                    _react2.default.createElement(
                        'span',
                        null,
                        (selectedKeys.length > 0 ? selectedKeys.length + '/' : '') + dataSource.length,
                        ' ',
                        unit
                    ),
                    _react2.default.createElement(
                        'span',
                        { className: _constants2.default + '-list-header-title' },
                        titleText
                    )
                )
            ) : null;

            var search = showSearch ? _react2.default.createElement(_search2.default, {
                value: this.state.filter,
                onChange: this.handleFilterWapper,
                handleClear: this.handleClear,
                prefixCls: _constants2.default + '-list-search',
                placeholder: searchPlaceholder
            }) : null;

            return _react2.default.createElement(
                'div',
                { className: className, style: style },
                header,
                search,
                _react2.default.createElement(_reactVirtualized.List, {
                    ref: function ref(list) {
                        _this3.list = list;
                    },
                    height: dataSource.length === 0 ? 0 : bodyHeight,
                    rowCount: dataSource.length,
                    rowHeight: this.props.rowHeight,
                    rowRenderer: this.rowRenderer,
                    width: 1,
                    className: _constants2.default + '-list-virtualized'
                }),
                dataSource.length === 0 && _react2.default.createElement(
                    'div',
                    {
                        className: _constants2.default + '-list-body-not-found',
                        style: {
                            height: bodyHeight + 'px',
                            lineHeight: bodyHeight + 'px'
                        }
                    },
                    notFoundContent
                ),
                listFooter
            );
        }
    }]);
    return SelectList;
}(_react2.default.Component);

exports.default = SelectList;


SelectList.defaultProps = {
    filterOption: undefined,
    footer: noop,
    showSearch: false,
    showHeader: true,
    itemUnit: '',
    itemsUnit: '',
    titleText: '',
    style: {
        width: 200,
        height: 300
    },
    notFoundContent: 'Not Found',
    searchPlaceholder: 'Search here',
    rowKey: undefined
};

SelectList.propTypes = {
    render: _propTypes2.default.func.isRequired,
    dataSource: _propTypes2.default.array.isRequired,
    selectedKeys: _propTypes2.default.array.isRequired,
    handleSelect: _propTypes2.default.func.isRequired,
    filterOption: _propTypes2.default.func,
    footer: _propTypes2.default.func,
    showSearch: _propTypes2.default.bool,
    showHeader: _propTypes2.default.bool,
    itemUnit: _propTypes2.default.string,
    itemsUnit: _propTypes2.default.string,
    titleText: _propTypes2.default.string,
    rowHeight: _propTypes2.default.number.isRequired,
    style: _propTypes2.default.shape({
        height: _propTypes2.default.number.isRequired, // not support %
        width: _propTypes2.default.any
    }),
    notFoundContent: _propTypes2.default.string,
    searchPlaceholder: _propTypes2.default.string,
    rowKey: _propTypes2.default.func
};