'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

require('react-virtualized/styles.css');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _PureRenderMixin = require('rc-util/lib/PureRenderMixin');

var _PureRenderMixin2 = _interopRequireDefault(_PureRenderMixin);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

require('core-js/fn/array/includes');

var _selectList = require('./selectList');

var _selectList2 = _interopRequireDefault(_selectList);

var _operation = require('./operation');

var _operation2 = _interopRequireDefault(_operation);

var _constants = require('./constants');

var _constants2 = _interopRequireDefault(_constants);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function noop() {}

var Transfer = function (_React$Component) {
    (0, _inherits3.default)(Transfer, _React$Component);

    function Transfer(props) {
        (0, _classCallCheck3.default)(this, Transfer);

        var _this = (0, _possibleConstructorReturn3.default)(this, (Transfer.__proto__ || (0, _getPrototypeOf2.default)(Transfer)).call(this, props));

        _this.state = {
            leftSource: [],
            rightSrouce: [],
            sourceSelectedKeys: [],
            targetSelectedKeys: []
        };

        _this.handleSelect = _this.handleSelect.bind(_this);
        _this.initStateByProps = _this.initStateByProps.bind(_this);
        _this.moveTo = _this.moveTo.bind(_this);
        _this.moveToLeft = _this.moveToLeft.bind(_this);
        _this.moveToRight = _this.moveToRight.bind(_this);
        return _this;
    }

    (0, _createClass3.default)(Transfer, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
            this.initStateByProps(this.props);
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if (nextProps.dataSource !== this.props.dataSource || nextProps.targetKeys !== this.props.targetKeys || nextProps.selectedKeys !== this.props.selectedKeys) {
                this.initStateByProps(nextProps, true);
            }
        }
    }, {
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate() {
            for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
                args[_key] = arguments[_key];
            }

            return _PureRenderMixin2.default.shouldComponentUpdate.apply(this, args);
        }
    }, {
        key: 'getSelectedKeysName',
        value: function getSelectedKeysName(direction) {
            return direction === 'left' ? 'sourceSelectedKeys' : 'targetSelectedKeys';
        }
    }, {
        key: 'initStateByProps',
        value: function initStateByProps(props, update) {
            var leftSource = [];
            var rightSrouce = new Array(props.targetKeys.length);
            var sourceSelectedKeys = [];
            var targetSelectedKeys = [];
            var oldSourceSelectedKeys = this.state.sourceSelectedKeys;
            var oldTargetSelectedKeys = this.state.targetSelectedKeys;

            props.dataSource.forEach(function (item) {
                if (props.rowKey) {
                    item.key = props.rowKey(item); // eslint-disable-line
                }

                // rightSource should be ordered by targetKeys
                // leftSource should be ordered by dataSource
                var indexOfKey = props.targetKeys.indexOf(item.key);
                if (indexOfKey !== -1) {
                    rightSrouce[indexOfKey] = item;
                } else {
                    leftSource.push(item);
                }

                if (!props.selectedKeys && update) {
                    // fitler not exist keys
                    if (oldSourceSelectedKeys.includes(item.key) && !props.targetKeys.includes(item.key)) {
                        sourceSelectedKeys.push(item.key);
                    }
                    if (oldTargetSelectedKeys.includes(item.key) && props.targetKeys.includes(item.key)) {
                        targetSelectedKeys.push(item.key);
                    }
                }
            });

            if (props.selectedKeys) {
                props.selectedKeys.forEach(function (key) {
                    if (props.targetKeys.includes(key)) {
                        targetSelectedKeys.push(key);
                    } else {
                        sourceSelectedKeys.push(key);
                    }
                });
            }

            this.setState({
                leftSource: leftSource,
                rightSrouce: rightSrouce,
                sourceSelectedKeys: sourceSelectedKeys,
                targetSelectedKeys: targetSelectedKeys
            });
        }
    }, {
        key: 'handleSelect',
        value: function handleSelect(direction, selectedKeys) {
            var leftKeys = direction === 'left' ? selectedKeys : this.state.sourceSelectedKeys;
            var rightKeys = direction === 'right' ? selectedKeys : this.state.targetSelectedKeys;
            var onSelectChange = this.props.onSelectChange;

            if (onSelectChange) {
                onSelectChange(leftKeys, rightKeys);
            }

            if (!this.props.selectedKeys) {
                this.setState({
                    sourceSelectedKeys: leftKeys,
                    targetSelectedKeys: rightKeys
                });
            }
        }
    }, {
        key: 'moveTo',
        value: function moveTo(direction) {
            var _props = this.props,
                _props$targetKeys = _props.targetKeys,
                targetKeys = _props$targetKeys === undefined ? [] : _props$targetKeys,
                _props$dataSource = _props.dataSource,
                dataSource = _props$dataSource === undefined ? [] : _props$dataSource,
                onChange = _props.onChange;
            var _state = this.state,
                sourceSelectedKeys = _state.sourceSelectedKeys,
                targetSelectedKeys = _state.targetSelectedKeys;

            var moveKeys = direction === 'right' ? sourceSelectedKeys : targetSelectedKeys;

            var newMoveKeys = [];
            // disable key can be selected in props, so there should fitler disabled keys
            dataSource.forEach(function (item) {
                if (!item.disabled && moveKeys.includes(item.key)) {
                    newMoveKeys.push(item.key);
                }
            });
            // move items to target box
            var newTargetKeys = direction === 'right' ? newMoveKeys.concat(targetKeys) : targetKeys.filter(function (targetKey) {
                return newMoveKeys.indexOf(targetKey) === -1;
            });
            // empty checked keys
            var oppositeDirection = direction === 'right' ? 'left' : 'right';
            this.setState((0, _defineProperty3.default)({}, this.getSelectedKeysName(oppositeDirection), []));
            this.handleSelect(oppositeDirection, []);
            if (onChange) {
                onChange(newTargetKeys, direction, newMoveKeys);
            }
        }
    }, {
        key: 'moveToLeft',
        value: function moveToLeft() {
            this.moveTo('left');
        }
    }, {
        key: 'moveToRight',
        value: function moveToRight() {
            this.moveTo('right');
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var _state2 = this.state,
                sourceSelectedKeys = _state2.sourceSelectedKeys,
                targetSelectedKeys = _state2.targetSelectedKeys;
            var _props2 = this.props,
                titles = _props2.titles,
                className = _props2.className,
                filterOption = _props2.filterOption,
                showSearch = _props2.showSearch,
                footer = _props2.footer,
                notFoundContent = _props2.notFoundContent,
                searchPlaceholder = _props2.searchPlaceholder;

            var leftActive = targetSelectedKeys.length > 0;
            var rightActive = sourceSelectedKeys.length > 0;

            var cls = (0, _classnames2.default)((0, _defineProperty3.default)({}, '' + _constants2.default, true), className);

            return _react2.default.createElement(
                'div',
                { className: cls },
                _react2.default.createElement(_selectList2.default, {
                    dataSource: this.state.leftSource,
                    render: this.props.render,
                    selectedKeys: this.state.sourceSelectedKeys,
                    handleSelect: function handleSelect(selectedKeys) {
                        return _this2.handleSelect('left', selectedKeys);
                    },
                    showSearch: showSearch,
                    filterOption: filterOption,
                    itemsUnit: 'items',
                    itemUnit: 'item',
                    titleText: titles[0],
                    rowHeight: this.props.rowHeight,
                    style: this.props.listStyle,
                    footer: footer,
                    notFoundContent: notFoundContent,
                    searchPlaceholder: searchPlaceholder
                }),
                _react2.default.createElement(_operation2.default, {
                    className: _constants2.default + '-operation',
                    leftActive: leftActive,
                    rightActive: rightActive,
                    moveToLeft: this.moveToLeft,
                    moveToRight: this.moveToRight,
                    leftArrowText: this.props.operations[0],
                    rightArrowText: this.props.operations[1]
                }),
                _react2.default.createElement(_selectList2.default, {
                    dataSource: this.state.rightSrouce,
                    render: this.props.render,
                    selectedKeys: this.state.targetSelectedKeys,
                    handleSelect: function handleSelect(selectedKeys) {
                        return _this2.handleSelect('right', selectedKeys);
                    },
                    showSearch: showSearch,
                    filterOption: filterOption,
                    itemsUnit: 'items',
                    itemUnit: 'item',
                    titleText: titles[1],
                    rowHeight: this.props.rowHeight,
                    style: this.props.listStyle,
                    footer: footer,
                    notFoundContent: notFoundContent,
                    searchPlaceholder: searchPlaceholder
                })
            );
        }
    }]);
    return Transfer;
}(_react2.default.Component);

exports.default = Transfer;


Transfer.defaultProps = {
    dataSource: [],
    selectedKeys: undefined,
    onSelectChange: undefined,
    titles: ['', ''],
    className: undefined,
    filterOption: undefined,
    listStyle: {
        width: 200,
        height: 300
    },
    operations: ['', ''],
    showSearch: false,
    footer: noop,
    notFoundContent: 'Not Found',
    searchPlaceholder: 'Search here',
    rowKey: undefined,
    onChange: undefined
};

Transfer.propTypes = {
    dataSource: _propTypes2.default.array,
    render: _propTypes2.default.func.isRequired,
    targetKeys: _propTypes2.default.array.isRequired,
    selectedKeys: _propTypes2.default.array,
    onChange: _propTypes2.default.func,
    onSelectChange: _propTypes2.default.func,
    listStyle: _propTypes2.default.shape({
        height: _propTypes2.default.number.isRequired, // not support %
        width: _propTypes2.default.any
    }),
    className: _propTypes2.default.string,
    titles: _propTypes2.default.array,
    operations: _propTypes2.default.array,
    showSearch: _propTypes2.default.bool,
    filterOption: _propTypes2.default.func,
    searchPlaceholder: _propTypes2.default.string,
    notFoundContent: _propTypes2.default.string,
    rowHeight: _propTypes2.default.number.isRequired,
    footer: _propTypes2.default.func,
    rowKey: _propTypes2.default.func };